﻿Public Class Protocol

    'Dim HV As New HuVECIIIKur          ''IKpL is replaced by IKur     INa gate is calculated using the probabilityPopen()

    Dim HV As New HuVECII          ''IKpL is replaced by IKur     INa gate is calculated using the probabilityPopen()


    '********** Graph option **********
    '********** prepared pens **********
    Public gradient5 As New Graph2018.GradientPen(5)         '(pen width)
    Public gradient4 As New Graph2018.GradientPen(4)         '(pen width)
    Public gradient3 As New Graph2018.GradientPen(3)         '(pen width)
    Public gradient2 As New Graph2018.GradientPen(2)         '(pen width)
    Public gradient1 As New Graph2018.GradientPen(1)         '(pen width)

    Dim graphVm As Graph2018
    Dim graphImo As Graph2018
    Dim graphImi As Graph2018
    Dim graphImt As Graph2018
    Dim graphabolition As Graph2018
    Dim graphGate As Graph2018
    Dim graphCai As Graph2018

    ''******************************   Graph2014 parameters **********************************
    Dim MinX1 As Double = 0                                      'msec, Abscissa of the graph
    Dim MaxX1 As Double = 500
    Dim IntervalX1 As Double = 50

    Dim MinY1 As Double = -100                          'mV, ordinate, graph of membrane potential
    Dim MaxY1 As Double = 60
    Dim IntervalY1 As Double = 20

    Dim MinY2o As Double = 0                           'pA/pF, or uM, ordinate , graph of ionic Currents
    Dim MaxY2o As Double = 1.601
    Dim IntervalY2o As Double = 0.2

    Dim MinY2i As Double = -1.6                       'pA/pF, or uM, ordinate , graph of ionic Currents
    Dim MaxY2i As Double = 0.01
    Dim IntervalY2i As Double = 0.2

    Dim MinY2t As Double = -0.4                       'pA/pF, or uM, ordinate , graph of ionic Currents
    Dim MaxY2t As Double = 1.301
    Dim IntervalY2t As Double = 0.2

    Dim MinY3 As Double = 0                         'unit, pOpen
    Dim MaxY3 As Double = 0.401
    Dim IntervalY3 As Double = 0.1

    Dim MinY4 As Double = 0                         'unit, pOpen
    Dim MaxY4 As Double = 0.401
    Dim IntervalY4 As Double = 0.1

    '********** Time step **********
    Public numSweep As Double                 'counter of sweeps
    Public Amplitude As Double = 0
    Public preAmplitude As Double = 0


    'Public preStim As Double
    'Public afterStim As Double
    'Public preVm As Double

    Public APdischarge As Boolean = False
    'Public flag3 As Boolean = True


    Public RepeatN As Double                       'Number of repeat the sweeps
    Public elapsedTime As Double               'msec, experimental time
    Public sweepTime As Double                 'msec   time for each sweep
    Dim TtoPlot As Double = 0                     'msec timing for plot the point
    Dim maxTtoPlot As Double = 0.5            '1 ms, interval of point plot

    '**********     counter     *********1********************************
    Dim fileNo As Integer                              'File handler
    Dim strData As String
    Dim valueArray() As String
    '***************************************** save data during simulation *******************************************************
    Dim CsvFileName As String = "CsvHuVEC.csv"
    Dim names1() As String = New String() {"Vm", "TnChCa", "CaMCa", "bufferSRCa", "Lb_jnc", "Lb_iz", "Hb_jnc", "Hb_iz", "Nai", "Ki",
    "Catot_jnc", "Catot_iz", "Catot_blk", "Ca_SRup", "Catot_SRrl", "O_TM", "I2_TM", "Is_TM", "O_LSM", "I1_LSM", "I2_LSM", "Is_LSM",
    "Yco_iz", "Yoc_iz", "Yoo_iz", "Yco_blk", "Yoc_blk", "Yoo_blk", "Yooo",
    "Yooc", "Ycoo", "Ycoc", "Ycco", "Yoco", "Yocc", "y1_IKr", "y2_IKr", "y3_IKr", "Ov_IKs", "C2IKs_iz",
    "OcIKs_iz", "C2IKs_blk", "OcIKs_blk", "y1_IKto", "y2_IKto", "Pbspm", "E1NCX_iz", "I1NCX_iz", "I2NCX_iz", "E1NCX_blk",
    "I1NCX_blk", "I2NCX_blk", "P1_6_NaK", "P7_NaK", "P8_13_NaK", "halfSL", "Fb", "Fp", "TSCa3", "TSCa3W",
    "TSCa3S", "TSS", "TSW", "hw", "hp", "ATPt_cyt", "ADPt_cyt", "Pi_cyt", "PCr_cyt", "ATPt_mit", "Pi_mit",
    "NADH_mit", "H_mit", "K_mit", "UQr_mit", "ctCrd_mit", "dpsi"}

    'Dim names1() As String = New String() {"Vm", "dVmdt", "Itot_cell", "Icompensation"}

    'Dim CsvFileNameA As String = "sumGX[.csv"
    'Dim nameA() As String = New String() {"INaL", "Catot_jnc", "Catot_iz", "Catot_blk", "Ca_SRup", "Catot_SRrl"}
    'Dim CsvFileNameB As String = "Vm[.csv"
    'Dim nameB() As String = New String() {"Vm"}
    'Dim CsvFileNameC As String = "ICaL[.csv"
    'Dim nameC() As String = New String() {"ICaL"}
    'Dim CsvFileNameD As String = "IKr[.csv"
    'Dim nameD() As String = New String() {"IKr"}
    'Dim CsvFileNameE As String = "IK1[.csv"
    'Dim nameE() As String = New String() {"IK1"}
    'Dim CsvFileNameF As String = "pO_mode1[.csv"
    'Dim nameF() As String = New String() {"pO_mode1"}


    '****************** Variables described below for mitochondria are not used in the present version *************

    Dim IsRecord As Boolean
    Dim FileName1 As String
    'Dim sw1 As StreamWriter
    Dim RecordTimeStart As Double
    Dim RecordDuration As Double
    Dim RecordInterval As Double
    Dim TtoRecord As Double

    Public Tfreeze As Double = 0
    Dim IsFreezeSlowV As Boolean = False
    Dim IsAddCaNa As Boolean = False
    Dim IsFreezeSR As Boolean = False

    Dim maxValue1 As Double = 0        'maximum rate of rise
    Dim maxValue2 As Double = 0        'peak Ca transient
    Dim maxValue3 As Double = 0        'APD90
    Dim maxValue4 As Double = 0        'peak Ca_iz
    Dim maxValue5 As Double = 0        'peak Ca_jnc
    Dim minValue1 As Double = 100

    Dim FluxL As Double                        'Sum of transition of CaRU induced by LCC activation
    Dim FluxR As Double                        'sum of transition of CaRU induced by spontaneous RyR openings

    Dim simVm(500000) As Double           'mV,    Vm reconstructed
    Dim preV As Double = 0
    Dim slopeVmax As Double = 0
    Dim sumRep As Double
    Dim NsumRep As Double
    Dim FirstDraw As Boolean = True

    Public dt As Double = 0.002          ' Definition of dt in the Model, because the value of dt is modified in this method, dt is stored in CSVRW
    Public adjustStepSize As Boolean = False      'used to determine if the adaptive dt is used or not
    Dim I As Long
    Dim limitST As Long                                 'ms     
    Public peakICaL As Double
    Public peakIK1 As Double
    Public peakTimeIK1 As Double
    Public previouspTIK1 As Double

    Public endLevel As Double = -20     'mV,   

    Public control As Boolean = False

    Private Sub ButtonStart_Click(sender As Object, e As EventArgs) Handles ButtonStart.Click
        '********  Just to indicate the name of this program name on the Desiner screen     This part is usually fixed *******************
        Dim appPath As String = System.Reflection.Assembly.GetExecutingAssembly().Location  '使用しているプログラムのDirectory
        TextBox1.Text = appPath                   'Print the whole directory to indicate which program is used
        '************** Analysis starts here ******************************

        ButtonStart.Visible = False       'hide the starting command button
        'ButtonEnd.Visible = False

        If FirstDraw = True Then                              'only when starting simulation
            DefineGraph()                                           'prepare graphs
            Clear()
            graphabolition.Clear()
            FirstDraw = False
        End If

        initialParameters()           'prepare for the analysis

        '********** prepare the graphabolition ************** prepare the graphabolition ****************
        graphabolition.DrawAxis(IntervalX1, IntervalY1, "", 8)
        'graphabolition.PlotLine(Soffset, MinY1, Soffset, MaxY1, Color.Black, 1)
        '************** numerical integration of the model ******************************
        HV.DefaultValues()    '******** get the intial model parameters *******************
        Dim I As Integer = 1
        Do                                         'Calculate a single sweep of HV.Vm  to show the control Vm time course
            sweepTime = I * dt
            If sweepTime >= ItestOn And sweepTime < ItestOff Then
                HV.Iext = Amplitude
            Else
                HV.Iext = 0
            End If

            HV.calculateModel(sweepTime, dt)          'calculate dydt(i) 
            HV.EulerIntegration(dt)
            simVm(I) = HV.Vm
            graphabolition.PlotPoint(sweepTime, simVm(I), Color.Black, 1, 1)    ''graph plot
            I = I + 1
        Loop While I * dt < MaxX1            '************************** END of one Sweep ******************************************
        My.Application.DoEvents()      'display the sweep

        '********* Analysis start **************** Analysis start **************** Analysis start ****************

        '******  Do Loop 1, Sonset *** Time ********  Do Loop 1 *** Time*******  Do Loop 1 *****************

        startVm = -70                 '6   -19    -54   -55
        testVm = startVm               'The first testVm at a new Sonset

        Do
            Clear()                'clear graphs
            DrawAxes()

            '******  Do Loop 2 *** testVm ******  Do Loop 2 *** testVm ********  Do Loop 2 ******************
            graphVm.PlotLine(Soffset, MinY1, Soffset, MaxY1, Color.Black, 1)
            graphImo.PlotLine(Soffset, MinY2o, Soffset, MaxY2o, Color.Black, 1)
            graphImi.PlotLine(Soffset, MinY2i, Soffset, MaxY2i, Color.Black, 1)
            graphGate.PlotLine(Soffset, MinY3, Soffset, MaxY3, Color.Black, 1)

            txtstartVm.Text = Format(startVm, "#0.#0")

            My.Application.DoEvents()

            'startVm = -55                '6   -19    -54   -55
            testVm = startVm               'The first testVm at a new Sonset

            Clear()                'clear graphs
            DrawAxes()
            Do

                txtVtest.Text = Format(testVm, "#0.#0")
                '******* reset measurements ****************************
                peakICaL = 0                'reset peakICaL
                APdischarge = False     'reset APdischarge
                peakIK1 = 0                  'reset peakIK1
                peakTimeIK1 = 0          'reset peakTimeIK1
                previouspTIK1 = 0        'rest previousTIK1

                '******  Do Loop 3 *** time integration of the model through the sweepTime ****  Do Loop 3 *****
                HV.DefaultValues()                   'reset the model parameter set
                sweepTime = 0                         'ms,
                Do                                              'Calculate individual sweep of the simulation
                    calculateIext(sweepTime, HV.Vm, testVm, HV.Iext)          'Iext described in the protocol
                    HV.calculateModel(sweepTime, dt)                                     'calculate dydt(i) of model parameters
                    HV.EulerIntegration(dt)                                                      'Euler numerical integration

                    '********** detect AP discharge by measurin the peakICaL ****** 
                    If sweepTime >= (Soffset + 10) Then                                      'determine peakICaL
                        If peakICaL > HV.ICaL Then
                            peakICaL = HV.ICaL 'search for the peak ICaL
                        End If
                    End If

                    'If sweepTime >= (Soffset + 10) Then                         'determine peakIK1 & peakTimeIK1
                    '    If peakIK1 < HV.IK1 Then                                          'search for the peak IK1
                    '        peakIK1 = HV.IK1
                    '        peakTimeIK1 = sweepTime
                    '    End If
                    'End If

                    ' ''''''''''''''''''''''''''''''''''''''''plot  results''''''''''''''''''''''''''''''''''''''''''''''''''''''''
                    If TtoPlot >= maxTtoPlot Then                       'time to plot
                        PlotResultsVmIm()
                        TtoPlot = 0                                        'reset the timer
                    Else
                        TtoPlot += dt                                      'msec, proceed with the timer 
                    End If

                    sweepTime += dt                'msec, proceed with the experimental time within one sweep
                Loop While sweepTime < MaxX1           '************************** END of one Sweep ******************************************

                My.Application.DoEvents()      'check events   display the time course of vm

                '************ analyse peakICaL for the AP discharge, peakIK1, peakTIK1 ****************
                txtpeakICaL.Text = Format(peakICaL, "#0.####0")
                If peakICaL < -0.9 Then
                    APdischarge = True
                    graphabolition.PlotPoint(Sonset, testVm, Color.Red, 4)         'record the threshold potential
                    'graphabolition.PlotLine(Sonset, MinY1, Sonset, MaxY1, Color.Blue, 1)
                    graphImi.PlotLine(sweepTime, MinY2i, sweepTime, MaxY2i, Color.Black, 1)  'Iindicate the peak time
                    Exit Do                            'get out of the Do Loop
                Else
                    APdischarge = False
                End If


                'Exit Do


                testVm += stpVS
                plateauVm = simVm(Sonset / dt - 1)
                'txtplateauPotential.Text = Format(plateauVm, "##0.##0")
            Loop While testVm <= oldVm '- 53.5  '     'oldVm is determined in the Iexternal().   (plateauVm - stpV)  'the plateau Vm 1ms before applying the VC pulse 

            'Exit Do


            '******** prepare for the next startVm and Sonset ********************
            If APdischarge = True Then
                startVm = testVm - 5 * stpVS
                'Else
            ElseIf testVm > plateauVm - stpVS Then
                startVm = plateauVm - 3 * stpVS
                '   startVm = plateauVm - 10 * stpVL
                graphabolition.PlotPoint(Sonset, simVm(Sonset / dt), Color.Green, 7)     'indicate failure to evoke AP
            End If

            Sonset += stpT
            Soffset = Sonset + pulseDuration
            txtSonset.Text = Format(Sonset, "##0.##0")
            txtSoffset.Text = Format(Soffset, "##0.##0")
            My.Application.DoEvents()
        Loop While startVm > (restVm + stpVS)        'compare the startVm with the resting Vm 
        'Loop While Sonset < (ItestOn + APD)                   'when Sonset is out of range 

        'graphabolition.PlotLine(HV.Soffset, MinY1, HV.Soffset, MaxY1, Color.Red, 1)

        ButtonStart.Visible = True                                                      'display the start button
        ButtonEnd.Visible = True                                                      'display the start button

    End Sub

    Public stpT As Double = 1                      'ms
    Public ItestOn As Double                       'ms
    Public ItestOff As Double                       'ms
    Public Samplitude As Double = -12        'pA/pF
    Public APD As Double = 380                  'ms

    Public Sonset As Double                     'ms
    Public Soffset As Double                     'ms
    Public pulseDuration As Double = 5         'ms
    Dim plateauVm As Double

    Public stpVS As Double = 0.2                'mV
    Public stpVL As Double = 2                'mV
    Public startVm As Double                   'mV
    Public testVm As Double = 0               'mV
    Public repeattestVm As Double           'dimensionless
    'Public limit_testVm As Double = 0               'mV


    Public fbgain As Double

    Public restVm As Double
    Public oldVm As Double
    Private Sub calculateIext(ByVal swt As Double, ByVal vm As Double, ByVal vtest As Double, ByRef iext As Double)
        fbgain = 1 / (10 * dt)                       'A 'feedback gain' is determined by the (x*dt) x=2 is best so far examined
        'fbgain = 1 / (2 * dt)                       'A 'feedback gain' is determined by the (x*dt) x=2 is best so far examined

        If swt < ItestOn Then restVm = HV.Vm          'detect the resting Vm
        If swt < Sonset Then oldVm = HV.Vm          'detect the last HV.Vm by replacing oldvm until swt < Sonset
        txtplateauPotential.Text = Format(oldVm, "##0.##0")

        If swt >= ItestOn And swt < ItestOff Then
            iext = Samplitude                                             'Iclamp
        ElseIf swt >= Sonset And swt < Soffset Then
            iext = -(vtest - vm) * fbgain                              'voltage clamp
        Else
            iext = 0
        End If
    End Sub

    Private Sub initialParameters()
        dt = 0.01                     'ms
        stpT = 2.0                    'ms
        stpVS = 0.5                    'mV,

        'startVm = 6               'mV  -52

        ItestOn = 20                 'ms
        ItestOff = ItestOn + 5     'ms     ItestOff = ItestOn + 3  
        Amplitude = -12            'pA/pF

        'Sonset = 170                 '170   95   50
        Sonset = ItestOn + 5 '+ 30    'ms
        pulseDuration = 5         'ms                   
        Soffset = Sonset + pulseDuration        'ms
        txtPulseDuration.Text = Format(pulseDuration, "#0.##0")
        APdischarge = False
        APD = 380                      'ms
    End Sub

    Private Sub MeasureMaxMin()
        If sweepTime < (HV.ItestOn - 1) Then
            HV.Vrest = HV.Vm                           'Vm at the end of diastole
            'HV.Carest_blk = HV.Cafree_blk        '[Ca2+] at the end of diastole
        End If
        If sweepTime < (HV.ItestOff + 10) Then HV.Vmaxpl = HV.Vm 'Vm at 10 msec after the offset of stimulus current pulse

        slopeVmax = (HV.Vm - preV) / dt     'measure the maximum rate of rise or fall
        preV = HV.Vm

    End Sub

    Private Sub ResetMeasurements()
        maxValue1 = 0                                    'to measure the maximum value of Fb 
        maxValue2 = 0
        maxValue3 = 0
        maxValue4 = 0
        maxValue5 = 0
        HV.Fbpeak = 0
        HV.minCa_ndLR = 100
        NsumRep = 0
        sumRep = 0
        FluxL = 0
        FluxR = 0
    End Sub

    Private Sub DefineGraph()
        graphVm = New Graph2018(pbVm, MinX1, MaxX1, MinY1, MaxY1)
        graphImo = New Graph2018(pbImo, MinX1, MaxX1, MinY2o, MaxY2o)
        graphImi = New Graph2018(pbImi, MinX1, MaxX1, MinY2i, MaxY2i)
        graphImt = New Graph2018(pbItot, MinX1, MaxX1, MinY2t, MaxY2t)
        graphGate = New Graph2018(pbGate, MinX1, MaxX1, MinY3, MaxY3)
        graphCai = New Graph2018(pbCai, MinX1, MaxX1, MinY4, MaxY4)

        graphabolition = New Graph2018(pbabolition, MinX1, MaxX1, MinY1, MaxY1)
    End Sub

    Private Sub DrawAxes()
        graphVm.DrawAxis(IntervalX1, IntervalY1, "", 8)
        graphImo.DrawAxis(IntervalX1, IntervalY2o, "", 8)
        graphImi.DrawAxis(IntervalX1, IntervalY2i, "", 8)
        graphImt.DrawAxis(IntervalX1, IntervalY2t, "", 8)
        graphCai.DrawAxis(IntervalX1, IntervalY4, "", 8)

        graphGate.DrawAxis(IntervalX1, IntervalY2t, "", 8)

        graphVm.PlotLine(Soffset, MinY1, Soffset, MaxY1, Color.Black, 1)
        graphImo.PlotLine(Soffset, MinY2o, Soffset, MaxY2o, Color.Black, 1)
        graphImi.PlotLine(Soffset, MinY2i, Soffset, MaxY2i, Color.Black, 1)
        graphImt.PlotLine(Soffset, MinY2t, Soffset, MaxY2t, Color.Black, 1)
        graphCai.PlotLine(Soffset, MinY4, Soffset, MaxY4, Color.Black, 1)

        graphGate.PlotLine(Soffset, MinY2t, Soffset, MaxY2t, Color.Black, 1)

    End Sub

    Dim oldINaL As Double       'previous INaL point = 0
    Dim oldRTime As Double     'previous plottime ms = 0

    Public pOpenCaL As Double
    Public pOpenNaL As Double
    Public pCloseCgate As Double

    Private Sub PlotResultsVmIm()
        'Dim I As Integer = sweepTime / dt

        graphVm.PlotPoint(sweepTime, HV.Vm, Color.Black, 2, 2)

        Dim IKtot As Double = HV.IKr_K_cyt + HV.IK1_K_cyt + HV.IKs_K_iz + HV.IKs_K_blk + HV.IKto_K_cyt + HV.IKpl_K_cyt

        graphImo.PlotPoint(sweepTime, IKtot, Color.LightGray, 2, 2)
        If chkIKr.Checked = True Then graphImo.PlotPoint(sweepTime, HV.IKr, Color.SteelBlue, 2, 2)
        If chkIK1.Checked = True Then graphImo.PlotPoint(sweepTime, HV.IK1, Color.Red, 2, 2)
        If chkIKto.Checked = True Then graphImo.PlotPoint(sweepTime, HV.IKto, Color.Black, 2, 2)
        If chkIKpl.Checked = True Then graphImo.PlotPoint(sweepTime, HV.IKpl, Color.Red, 2, 2)
        'If chkIKpl.Checked = True Then graphImo.PlotPoint(sweepTime, HV.IKur_K_cyt, Color.Red, 2, 2)
        graphImo.PlotPoint(sweepTime, HV.INaK, Color.Pink, 2, 2)
        If chkIKs.Checked = True Then graphImo.PlotPoint(sweepTime, HV.IKs, Color.Teal, 2, 2)

        graphImi.PlotPoint(sweepTime, HV.ICaL + HV.INaL + HV.IbNSC, Color.LightGray, 2, 2)
        If chkINaTreduced.Checked Then graphImi.PlotPoint(sweepTime, HV.INaT / 100, Color.IndianRed, 2, 2)
        If chkICaL.Checked Then graphImi.PlotPoint(sweepTime, HV.ICaL, Color.Chocolate, 2, 2)
        If chkINaL.Checked Then graphImi.PlotPoint(sweepTime, HV.INaL, Color.Blue, 2, 2)
        If chkIbNSC.Checked Then graphImi.PlotPoint(sweepTime, HV.IbNSC, Color.Black, 2, 2)

        graphImt.PlotPoint(sweepTime, HV.Itot_cell, Color.Black, 2, 2)

        pOpenCaL = HV.Yoo_blk * HV.FrcCaL_blk + HV.Yoo_iz * HV.FrcCaL_iz + HV.po_LCC * HV.FrcCaL_jnc
        'pOpenNaL = HV.O_LM
        'pCloseCgate = (HV.Yoc_blk + HV.Ycc_blk) * HV.FrcCaL_blk + (HV.Yoc_iz + HV.Ycc_iz) * HV.FrcCaL_iz
        'pCloseCgate += (HV.Yoco + HV.Yocc + HV.Ycco + HV.Yccc) * HV.FrcCaL_jnc

        If chkpOCaL.Checked Then graphGate.PlotPoint(sweepTime, pOpenCaL * 2, Color.Chocolate, 2, 2)
        If chkpONaL.Checked Then graphGate.PlotPoint(sweepTime, HV.O_LM * 100, Color.Blue, 2, 2)
        If chkpOK1.Checked Then graphGate.PlotPoint(sweepTime, HV.pO_IK1, Color.Red, 2, 2)
        If chkpOKr.Checked Then graphGate.PlotPoint(sweepTime, HV.pO_IKr, Color.SteelBlue, 2, 2)
        If chkpOKto.Checked Then graphGate.PlotPoint(sweepTime, HV.pO_IKto, Color.Black, 2, 2)

        'graphGate.PlotPoint(sweepTime, pCloseCgate, Color.Violet, 2, 2)

        graphCai.PlotPoint(sweepTime, HV.Cafree_blk * 1000, Color.Black, 2, 2)

        'graphabolition.PlotPoint(sweepTime, HV.Vm, Color.Black,2, 2)

    End Sub

    Private Sub WritetxtBox()
        txtdVmdt.Text = Format(maxValue1, "###.# V/s")    'maximum rate of rise of AP
        txtRep.Text = Format(minValue1, "##.# V/s")    'maximum rate of rise of AP
        txtNai.Text = Format(HV.Nai, "##.## mM")
        txtCapeak.Text = Format(maxValue2 * 1000, "##.## uM")
        txtCajnc.Text = Format(maxValue5 * 1000, "###.## uM")
        txtCaiz.Text = Format(maxValue4 * 1000, "###.## uM")

        txtAPD.Text = Format(maxValue3, "###.## ms")
        txtCa_ndLR.Text = Format(HV.minCa_ndLR * 1000, "###.## uM")
        txtCaSR.Text = Format(HV.Cafree_SRrl, "##.## mM")
        txtpeakIK1.Text = Format(HV.Vrest, "####.### mV")
        txtATPcyt.Text = Format(HV.ATPt_cyt, " #.### ")
        txtATPmit.Text = Format(HV.ATPt_mit, " #.### ")
        HV.Sig_INa = HV.Sig_INa + HV.INaT_Na_cyt + HV.INaL_Na_cyt
        HV.Sig_INCXNa = HV.Sig_INCXNa + HV.INCXNa_iz + HV.INCXNa_blk
        HV.Sig_allNa = HV.Sig_allNa + HV.ItotNa_cyt


    End Sub


    Private Sub Clear()
        graphVm.Clear()
        graphImo.Clear()
        graphImi.Clear()
        graphImt.Clear()
        graphCai.Clear()
        graphGate.Clear()
    End Sub



    Private Sub cbReset_Click(sender As Object, e As EventArgs) Handles cbReset.Click
        numSweep = RepeatN + 1
    End Sub

    Private Sub cbErase_Click(sender As Object, e As EventArgs) Handles cbErase.Click
        Clear()
        DrawAxes()
        control = False
    End Sub

    Private Sub ButtonEnd_Click(sender As Object, e As EventArgs) Handles ButtonEnd.Click
        End
    End Sub

End Class
